# IShTokenStream Struct Reference
[Shell Interfaces]

Inheritance diagram for IShTokenStream:

List of all members.

## Public Member Functions
template<class Array >
void | PutArrayAttribute (int32 keyword, const Array &array, const boolean multiLine=false)
template<class Array >
void | GetArrayToken (Array &array, const boolean multiLine=false)
template<class T >
void | GetCountedPtrArrayToken (TMCCountedPtrArray< T > &array, const boolean multiLine=false)
virtual void MCCOMAPI | GetBeginToken ()=0
virtual void MCCOMAPI | GetEndToken ()=0
virtual MCCOMErr MCCOMAPI | GetNextToken (int8 *token)=0
virtual int32 MCCOMAPI | CompactAttribute (const int8 *attrName)=0
virtual boolean MCCOMAPI | IsEndToken (int8 *atoken)=0
virtual boolean MCCOMAPI | IsBeginToken (int8 *token)=0
virtual int32 MCCOMAPI | GetKeyword ()=0
virtual void MCCOMAPI | SkipTokenData ()=0
virtual void MCCOMAPI | SkipTokenData (boolean beginTokenWasRead)=0
virtual int8 MCCOMAPI | GetInt8Token ()=0
virtual int16 MCCOMAPI | GetInt16Token ()=0
virtual int32 MCCOMAPI | GetInt32Token ()=0
virtual uint8 MCCOMAPI | GetUInt8Token ()=0
virtual uint16 MCCOMAPI | GetUInt16Token ()=0
virtual uint32 MCCOMAPI | GetUInt32Token ()=0
virtual real32 MCCOMAPI | GetReal32Token ()=0
virtual real64 MCCOMAPI | GetReal64Token ()=0
virtual int32 MCCOMAPI | GetFourCharConstToken ()=0
virtual uint32 MCCOMAPI | GetEnumToken ()=0
virtual boolean MCCOMAPI | GetBooleanToken ()=0
virtual TMCPoint MCCOMAPI | GetPointToken ()=0
virtual TMCRect MCCOMAPI | GetRectToken ()=0
virtual void MCCOMAPI | GetInt16ArrayToken (int32 nb, int16 *valArray)=0
virtual void MCCOMAPI | GetInt32ArrayToken (int32 nb, int32 *valArray)=0
virtual void MCCOMAPI | GetReal32ArrayToken (int32 nb, real32 *valArray)=0
virtual TMCString255 MCCOMAPI | GetStringToken ()=0
virtual void MCCOMAPI | GetRGBColorToken (TMCColorRGB &color)=0
virtual void MCCOMAPI | GetVector3Token (TVector3 &vector)=0
virtual void MCCOMAPI | GetInt16ArrayToken (TMCArray< int16 > &valArray)=0
virtual void MCCOMAPI | GetInt32ArrayToken (TMCArray< int32 > &valArray)=0
virtual void MCCOMAPI | GetReal32ArrayToken (TMCArray< real32 > &valArray)=0
virtual void MCCOMAPI | GetVector3ArrayToken (TMCArray< TVector3 > &valArray)=0
virtual void MCCOMAPI | GetVector2ArrayToken (TMCArray< TVector2 > &valArray)=0
virtual void MCCOMAPI | GetBooleanArrayToken (TMCArray< boolean > &valArray)=0
virtual void MCCOMAPI | GetGenericArrayToken (ITokenStreamArrayReader &array, const boolean multiLine=false)=0
virtual void MCCOMAPI | PutBeginToken (int32 keyword=0)=0
virtual void MCCOMAPI | PutEndToken ()=0
virtual void MCCOMAPI | PutFourCharConstAttribute (int32 keyword, int32 token)=0
virtual void MCCOMAPI | PutInt8Attribute (int32 keyword, int8 value)=0
virtual void MCCOMAPI | PutInt16Attribute (int32 keyword, int16 value)=0
virtual void MCCOMAPI | PutInt32Attribute (int32 keyword, int32 value)=0
virtual void MCCOMAPI | PutUInt8Attribute (int32 keyword, uint8 value)=0
virtual void MCCOMAPI | PutUInt16Attribute (int32 keyword, uint16 value)=0
virtual void MCCOMAPI | PutUInt32Attribute (int32 keyword, uint32 value)=0
virtual void MCCOMAPI | PutReal32Attribute (int32 keyword, real32 value)=0
virtual void MCCOMAPI | PutReal64Attribute (int32 keyword, real64 value)=0
virtual void MCCOMAPI | PutEnumAttribute (int32 keyword, uint32 value)=0
virtual void MCCOMAPI | PutBooleanAttribute (int32 keyword, boolean value)=0
virtual void MCCOMAPI | PutPointAttribute (int32 keyword, const TMCPoint &inPoint)=0
virtual void MCCOMAPI | PutRectAttribute (int32 keyword, const TMCRect &inRect)=0
virtual void MCCOMAPI | PutInt32ArrayAttribute (int32 keyword, int32 nb, int32 *valArray)=0
virtual void MCCOMAPI | PutInt16ArrayAttribute (int32 keyword, int32 nb, int16 *valArray)=0
virtual void MCCOMAPI | PutReal32ArrayAttribute (int32 keyword, int32 nb, const real32 *valArray)=0
virtual void MCCOMAPI | PutStringAttribute (int32 keyword, const TMCString &str)=0
virtual void MCCOMAPI | PutRGBColorAttribute (IDType keyword, const TMCColorRGB &color)=0
virtual void MCCOMAPI | PutVector3Attribute (IDType keyword, const TVector3 &vector)=0
virtual void MCCOMAPI | PutInt16ArrayAttribute (int32 keyword, const TMCArray< int16 > &valArray)=0
virtual void MCCOMAPI | PutInt32ArrayAttribute (int32 keyword, const TMCArray< int32 > &valArray)=0
virtual void MCCOMAPI | PutReal32ArrayAttribute (int32 keyword, const TMCArray< real32 > &valArray)=0
virtual void MCCOMAPI | PutVector3ArrayAttribute (int32 keyword, const TMCArray< TVector3 > &theArray)=0
virtual void MCCOMAPI | PutVector2ArrayAttribute (int32 keyword, const TMCArray< TVector2 > &theArray)=0
virtual void MCCOMAPI | PutBooleanArrayAttribute (int32 keyword, const TMCArray< boolean > &theArray)=0
virtual void MCCOMAPI | PutGenericArrayAttribute (IDType keyword, ITokenStreamArrayWriter &array, const boolean multiLine=false)=0
virtual MCCOMErr MCCOMAPI | GetBegin ()=0
virtual MCCOMErr MCCOMAPI | GetEnd ()=0
virtual MCCOMErr MCCOMAPI | GetKeyword (int32 *keyword)=0
virtual MCCOMErr MCCOMAPI | GetInt32 (int32 *value)=0
virtual MCCOMErr MCCOMAPI | GetQuickFix (real *value)=0
virtual MCCOMErr MCCOMAPI | GetPoint2D (real *x, real *y)=0
virtual MCCOMErr MCCOMAPI | GetPoint3D (real *x, real *y, real *z)=0
virtual MCCOMErr MCCOMAPI | GetShortArray (int32 nb, int16 *valArray)=0
virtual MCCOMErr MCCOMAPI | GetInt32Array (int32 nb, int32 *valArray)=0
virtual MCCOMErr MCCOMAPI | GetString (int8 *astring)=0
virtual MCCOMErr MCCOMAPI | GetArray (int32 nb, real *valArray)=0
virtual MCCOMErr MCCOMAPI | GetMat33 (real &m00, real &m01, real &m02, real &m10, real &m11, real &m12, real &m20, real &m21, real &m22)=0
virtual real32 MCCOMAPI | GetReal32 ()=0
virtual void MCCOMAPI | GetRGBColor (TMCColorRGB &color)=0
virtual void MCCOMAPI | GetVector3 (TVector3 &vector)=0
virtual MCCOMErr MCCOMAPI | CompactAttribute (int8 *atoken, int32 *keyword)=0
virtual MCCOMErr MCCOMAPI | Indent ()=0
virtual MCCOMErr MCCOMAPI | PutKeyword (int32 keyword)=0
virtual MCCOMErr MCCOMAPI | PutKeywordAndBegin (int32 keyword)=0
virtual MCCOMErr MCCOMAPI | PutEnd ()=0
virtual MCCOMErr MCCOMAPI | PutBegin ()=0
virtual MCCOMErr MCCOMAPI | PutInt32 (int32 along)=0
virtual MCCOMErr MCCOMAPI | PutQuickFix (real avalue)=0
virtual MCCOMErr MCCOMAPI | PutPoint2D (real x, real y)=0
virtual MCCOMErr MCCOMAPI | PutPoint3D (real x, real y, real z)=0
virtual MCCOMErr MCCOMAPI | PutShortArray (int32 nb, const int16 *valArray)=0
virtual MCCOMErr MCCOMAPI | PutInt32Array (int32 nb, const int32 *valArray)=0
virtual MCCOMErr MCCOMAPI | PutString (const int8 *astring)=0
virtual MCCOMErr MCCOMAPI | PutArray (int32 nb, const real *valArray)=0
virtual MCCOMErr MCCOMAPI | PutMat33 (real m00, real m01, real m02, real m10, real m11, real m12, real m20, real m21, real m22)=0
virtual void MCCOMAPI | BeginBufferAsBinHex (uint32 &lastInfo)=0
virtual void MCCOMAPI | PutBufferAsBinHex (int8 *data, int32 count, uint32 &lastInfo)=0
virtual void MCCOMAPI | GetBufferAsBinHex (int8 *data, int32 count, uint32 &lastInfo)=0
virtual void MCCOMAPI | EndPutBufferAsBinHex (uint32 &lastInfo)=0
virtual TMCiostream &MCCOMAPI | GetStream ()=0
virtual MCCOMErr MCCOMAPI | InitTokenMgr ()=0
virtual IStreamContext *MCCOMAPI | GetStreamContext () const =0
virtual void MCCOMAPI | PutUint16ArrayAttribute (int32 keyword, const TMCArray< uint16 > &theArray)=0

## Detailed Description

Interface for token streams. See MCToken.h for token definitions used. Used to read/write tokenized data files (as are standard for Carrara) as in the following simple example, which reads in the position of a vertex:

     MCCOMErr ReadVertex(IShTokenStream* inStream,int8 *token, I3DExVertex* vertex)
     {
                    ThrowIfNil(vertex);
                    stream->GetNextToken(token);
                    if (token[0] != tBEGIN)
                    {
                            return MC_ERROR_FILE_NOT_FOUND;
                    }
                    stream->GetNextToken(token);
                    int32 key;
                    TVector3 position = TVector3::kZero;
                    while (!stream->IsEndToken(token))
                    {
                            stream->CompactAttribute(token,&key);
                            switch (key)
                            {
                                    case 'posi':
                                            stream->GetPoint3D(&(position.x), &(position.y), &(position.z))
                                            break;
                                    default:
                                            stream->SkipTokenData();
                                            break;
                            }
                            stream->GetNextToken(token);
                    }
                    vertex->SetPosition(position);
            }

Before reading or writing a new file, call InitTokenMgr() to initialize various variables (such as indentation size).

To read and write binary data in a tokenized text file, we must encode them as text. BeginBufferAsBinHex(), PutBufferAsBinHex(), GetBufferAsBinHex(), and EndPutBufferAsBinHex() handle this functionality.

## Member Function Documentation

virtual void MCCOMAPI IShTokenStream::BeginBufferAsBinHex | ( | uint32 & | lastInfo | ) | `[pure virtual]`

Initialise the saving of a binary buffer into a text stream. Should be called before PutBufferAsBinHex.

Parameters:

  | lastInfo | Pass this a 0. This will be used by PutBufferAsBinHex and EndBufferAsBinHex.

virtual MCCOMErr MCCOMAPI IShTokenStream::CompactAttribute | ( | int8 * | atoken,
|  | int32 * | keyword |
| ) |  |  | `[pure virtual]`

virtual int32 MCCOMAPI IShTokenStream::CompactAttribute | ( | const int8 * | attrName | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::EndPutBufferAsBinHex | ( | uint32 & | lastInfo | ) | `[pure virtual]`

Finish saving a binary buffer. lastInfo should come from the last call to PutBufferAsBinHex.

Parameters:

  | lastInfo | From the last PutBufferAsBinHex

virtual MCCOMErr MCCOMAPI IShTokenStream::GetArray | ( | int32 | nb,
|  | real * | valArray |
| ) |  |  | `[pure virtual]`

template<class Array >

void IShTokenStream::GetArrayToken | ( | Array & | array,
|  | const boolean | multiLine = `false` |
| ) |  |  | `[inline]`

virtual MCCOMErr MCCOMAPI IShTokenStream::GetBegin | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::GetBeginToken | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::GetBooleanArrayToken | ( | TMCArray< boolean > & | valArray | ) | `[pure virtual]`

virtual boolean MCCOMAPI IShTokenStream::GetBooleanToken | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::GetBufferAsBinHex | ( | int8 * | data,
|  | int32 | count,
|  | uint32 & | lastInfo |
| ) |  |  | `[pure virtual]`

Load a binary buffer from a text stream. lastInfo should come from the last call to GetBufferAsBinHex or from BeginBufferAsBinHex.

Parameters:

  | data | pointer to the buffer to fill
  | count | number of bytes to fill
  | lastInfo | From the last GetBufferAsBinHex or BeginBufferAsBinHex call

template<class T >

void IShTokenStream::GetCountedPtrArrayToken | ( | TMCCountedPtrArray< T > & | array,
|  | const boolean | multiLine = `false` |
| ) |  |  | `[inline]`

virtual MCCOMErr MCCOMAPI IShTokenStream::GetEnd | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::GetEndToken | ( |  | ) | `[pure virtual]`

virtual uint32 MCCOMAPI IShTokenStream::GetEnumToken | ( |  | ) | `[pure virtual]`

virtual int32 MCCOMAPI IShTokenStream::GetFourCharConstToken | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::GetGenericArrayToken | ( | ITokenStreamArrayReader & | array,
|  | const boolean | multiLine = `false` |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::GetInt16ArrayToken | ( | TMCArray< int16 > & | valArray | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::GetInt16ArrayToken | ( | int32 | nb,
|  | int16 * | valArray |
| ) |  |  | `[pure virtual]`

virtual int16 MCCOMAPI IShTokenStream::GetInt16Token | ( |  | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::GetInt32 | ( | int32 * | value | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::GetInt32Array | ( | int32 | nb,
|  | int32 * | valArray |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::GetInt32ArrayToken | ( | TMCArray< int32 > & | valArray | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::GetInt32ArrayToken | ( | int32 | nb,
|  | int32 * | valArray |
| ) |  |  | `[pure virtual]`

virtual int32 MCCOMAPI IShTokenStream::GetInt32Token | ( |  | ) | `[pure virtual]`

virtual int8 MCCOMAPI IShTokenStream::GetInt8Token | ( |  | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::GetKeyword | ( | int32 * | keyword | ) | `[pure virtual]`

virtual int32 MCCOMAPI IShTokenStream::GetKeyword | ( |  | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::GetMat33 | ( | real & | m00,
|  | real & | m01,
|  | real & | m02,
|  | real & | m10,
|  | real & | m11,
|  | real & | m12,
|  | real & | m20,
|  | real & | m21,
|  | real & | m22 |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::GetNextToken | ( | int8 * | token | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::GetPoint2D | ( | real * | x,
|  | real * | y |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::GetPoint3D | ( | real * | x,
|  | real * | y,
|  | real * | z |
| ) |  |  | `[pure virtual]`

virtual TMCPoint MCCOMAPI IShTokenStream::GetPointToken | ( |  | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::GetQuickFix | ( | real * | value | ) | `[pure virtual]`

virtual real32 MCCOMAPI IShTokenStream::GetReal32 | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::GetReal32ArrayToken | ( | TMCArray< real32 > & | valArray | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::GetReal32ArrayToken | ( | int32 | nb,
|  | real32 * | valArray |
| ) |  |  | `[pure virtual]`

virtual real32 MCCOMAPI IShTokenStream::GetReal32Token | ( |  | ) | `[pure virtual]`

virtual real64 MCCOMAPI IShTokenStream::GetReal64Token | ( |  | ) | `[pure virtual]`

virtual TMCRect MCCOMAPI IShTokenStream::GetRectToken | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::GetRGBColor | ( | TMCColorRGB & | color | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::GetRGBColorToken | ( | TMCColorRGB & | color | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::GetShortArray | ( | int32 | nb,
|  | int16 * | valArray |
| ) |  |  | `[pure virtual]`

virtual TMCiostream& MCCOMAPI IShTokenStream::GetStream | ( |  | ) | `[pure virtual]`

virtual IStreamContext* MCCOMAPI IShTokenStream::GetStreamContext | ( |  | ) | const`[pure virtual]`

Gets the stream context (see TMCiostream).

virtual MCCOMErr MCCOMAPI IShTokenStream::GetString | ( | int8 * | astring | ) | `[pure virtual]`

virtual TMCString255 MCCOMAPI IShTokenStream::GetStringToken | ( |  | ) | `[pure virtual]`

virtual uint16 MCCOMAPI IShTokenStream::GetUInt16Token | ( |  | ) | `[pure virtual]`

virtual uint32 MCCOMAPI IShTokenStream::GetUInt32Token | ( |  | ) | `[pure virtual]`

virtual uint8 MCCOMAPI IShTokenStream::GetUInt8Token | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::GetVector2ArrayToken | ( | TMCArray< TVector2 > & | valArray | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::GetVector3 | ( | TVector3 & | vector | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::GetVector3ArrayToken | ( | TMCArray< TVector3 > & | valArray | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::GetVector3Token | ( | TVector3 & | vector | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::Indent | ( |  | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::InitTokenMgr | ( |  | ) | `[pure virtual]`

InitTokenMgr() should be called every time before reading or writing a new file. The parameter sets gTokenAsciiFormat (this controls ASCII translation). Other globals like the indentation level are reset to their default values too.

virtual boolean MCCOMAPI IShTokenStream::IsBeginToken | ( | int8 * | token | ) | `[pure virtual]`

virtual boolean MCCOMAPI IShTokenStream::IsEndToken | ( | int8 * | atoken | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::PutArray | ( | int32 | nb,
|  | const real * | valArray |
| ) |  |  | `[pure virtual]`

template<class Array >

void IShTokenStream::PutArrayAttribute | ( | int32 | keyword,
|  | const Array & | array,
|  | const boolean | multiLine = `false` |
| ) |  |  | `[inline]`

virtual MCCOMErr MCCOMAPI IShTokenStream::PutBegin | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutBeginToken | ( | int32 | keyword = `0` | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutBooleanArrayAttribute | ( | int32 | keyword,
|  | const TMCArray< boolean > & | theArray |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutBooleanAttribute | ( | int32 | keyword,
|  | boolean | value |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutBufferAsBinHex | ( | int8 * | data,
|  | int32 | count,
|  | uint32 & | lastInfo |
| ) |  |  | `[pure virtual]`

Save a binary buffer into a text stream. lastInfo should come from the last call to PutBufferAsBinHex or from BeginBufferAsBinHex.

Parameters:

  | data | pointer to the buffer to save
  | count | number of bytes of data in the buffer
  | lastInfo | From the last PutBufferAsBinHex or BeginBufferAsBinHex call

virtual MCCOMErr MCCOMAPI IShTokenStream::PutEnd | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutEndToken | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutEnumAttribute | ( | int32 | keyword,
|  | uint32 | value |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutFourCharConstAttribute | ( | int32 | keyword,
|  | int32 | token |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutGenericArrayAttribute | ( | IDType | keyword,
|  | ITokenStreamArrayWriter & | array,
|  | const boolean | multiLine = `false` |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutInt16ArrayAttribute | ( | int32 | keyword,
|  | const TMCArray< int16 > & | valArray |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutInt16ArrayAttribute | ( | int32 | keyword,
|  | int32 | nb,
|  | int16 * | valArray |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutInt16Attribute | ( | int32 | keyword,
|  | int16 | value |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::PutInt32 | ( | int32 | along | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::PutInt32Array | ( | int32 | nb,
|  | const int32 * | valArray |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutInt32ArrayAttribute | ( | int32 | keyword,
|  | const TMCArray< int32 > & | valArray |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutInt32ArrayAttribute | ( | int32 | keyword,
|  | int32 | nb,
|  | int32 * | valArray |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutInt32Attribute | ( | int32 | keyword,
|  | int32 | value |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutInt8Attribute | ( | int32 | keyword,
|  | int8 | value |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::PutKeyword | ( | int32 | keyword | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::PutKeywordAndBegin | ( | int32 | keyword | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::PutMat33 | ( | real | m00,
|  | real | m01,
|  | real | m02,
|  | real | m10,
|  | real | m11,
|  | real | m12,
|  | real | m20,
|  | real | m21,
|  | real | m22 |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::PutPoint2D | ( | real | x,
|  | real | y |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::PutPoint3D | ( | real | x,
|  | real | y,
|  | real | z |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutPointAttribute | ( | int32 | keyword,
|  | const TMCPoint & | inPoint |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::PutQuickFix | ( | real | avalue | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutReal32ArrayAttribute | ( | int32 | keyword,
|  | const TMCArray< real32 > & | valArray |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutReal32ArrayAttribute | ( | int32 | keyword,
|  | int32 | nb,
|  | const real32 * | valArray |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutReal32Attribute | ( | int32 | keyword,
|  | real32 | value |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutReal64Attribute | ( | int32 | keyword,
|  | real64 | value |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutRectAttribute | ( | int32 | keyword,
|  | const TMCRect & | inRect |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutRGBColorAttribute | ( | IDType | keyword,
|  | const TMCColorRGB & | color |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::PutShortArray | ( | int32 | nb,
|  | const int16 * | valArray |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI IShTokenStream::PutString | ( | const int8 * | astring | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutStringAttribute | ( | int32 | keyword,
|  | const TMCString & | str |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutUint16ArrayAttribute | ( | int32 | keyword,
|  | const TMCArray< uint16 > & | theArray |
| ) |  |  | `[pure virtual]`

Write an array of int16 (added in 6.1)

virtual void MCCOMAPI IShTokenStream::PutUInt16Attribute | ( | int32 | keyword,
|  | uint16 | value |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutUInt32Attribute | ( | int32 | keyword,
|  | uint32 | value |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutUInt8Attribute | ( | int32 | keyword,
|  | uint8 | value |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutVector2ArrayAttribute | ( | int32 | keyword,
|  | const TMCArray< TVector2 > & | theArray |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutVector3ArrayAttribute | ( | int32 | keyword,
|  | const TMCArray< TVector3 > & | theArray |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::PutVector3Attribute | ( | IDType | keyword,
|  | const TVector3 & | vector |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::SkipTokenData | ( | boolean | beginTokenWasRead | ) | `[pure virtual]`

virtual void MCCOMAPI IShTokenStream::SkipTokenData | ( |  | ) | `[pure virtual]`

The documentation for this struct was generated from the following file:

- IShTokenStream.h